Subject: Re: ip6-in-ip{4,6} ipsec tunnel issues with 1280 MTU

From: Ashwanth Goli <[email-masked]>
Date: Fri, 27 Apr 2018 16:32:06 +0530

On 2018-04-26 17:21, Paolo Abeni wrote:
> Hi,
> 
> [fixed CC list]
> 
> On Wed, 2018-04-25 at 21:43 +0530, Ashwanth Goli wrote:
>> Hi Pablo,
> 
> Actually I'm Paolo, but yours is a recurring mistake ;)
> 
>> I am noticing an issue similar to the one reported by Alexis Perez
>> [Regression for ip6-in-ip4 IPsec tunnel in 4.14.16]
>> 
>> In my IPsec setup outer MTU is set to 1280, ip6_setup_cork sees an MTU
>> less than IPV6_MIN_MTU because of the tunnel headers. -EINVAL is being
>> returned as a result of the MTU check that got added with below patch.
>> 
>> https://git.kernel.org/pub/scm/linux/kernel/git/stable/linux-stable.git/commit/net/ipv6/ip6_output.c?h=v4.14.34&id=8278804e05f6bcfe3fdfea4a404020752ead15a6
>> 
>> Can we remove this MTU check since your recent patch [ipv6: the entire
>> IPv6 header chain must fit the first fragment] fixes a similar issue?
> 
> AFAICS, RFC 2473 implies we can have MTU below 1280 for tunnel devices
> so we can probably relax the MTU check for such devices, but I think we
> would still need it in the general case.
> 
> Cheers,
> 
> Paolo

Should I send out the following change as a patch?

diff --git a/net/ipv6/ip6_output.c b/net/ipv6/ip6_output.c
index 2e891d2..c4c3313 100644
--- a/net/ipv6/ip6_output.c
+++ b/net/ipv6/ip6_output.c
@@ -1235,7 +1235,7 @@ static int ip6_setup_cork(struct sock *sk, struct 
inet_cork_full *cork,
          if (np->frag_size)
              mtu = np->frag_size;
      }
-    if (mtu < IPV6_MIN_MTU)
+  if (!(rt->dst.flags & DST_XFRM_TUNNEL) && mtu < IPV6_MIN_MTU)
          return -EINVAL;
      cork->base.fragsize = mtu;
      if (dst_allfrag(xfrm_dst_path(&rt->dst)))